<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: appCNNInteropCaffe</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">appCNNInteropCaffe<div class="ingroups"><a class="el" href="group__appCNN.html">appCNN</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>CNN Caffe interoperation applications.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga0ddf1224851353fc92bfbff6f499fa97"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga0ddf1224851353fc92bfbff6f499fa97">main</a> (int argc, char *argv[])</td></tr>
<tr class="memdesc:ga0ddf1224851353fc92bfbff6f499fa97"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe to TIML CNN model converter.  <a href="#ga0ddf1224851353fc92bfbff6f499fa97">More...</a><br/></td></tr>
<tr class="separator:ga0ddf1224851353fc92bfbff6f499fa97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7052f4eb157d65957ad3fd2332438522"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga7052f4eb157d65957ad3fd2332438522">appCNNInteropCaffeReadProtoFromTextFile</a> (const char *fileName, Message *proto)</td></tr>
<tr class="memdesc:ga7052f4eb157d65957ad3fd2332438522"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe read proto from text file.  <a href="#ga7052f4eb157d65957ad3fd2332438522">More...</a><br/></td></tr>
<tr class="separator:ga7052f4eb157d65957ad3fd2332438522"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga622145415a86ef826c3e8017fb478db6"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga622145415a86ef826c3e8017fb478db6">appCNNInteropCaffeReadProtoFromBinaryFile</a> (const char *fileName, Message *proto)</td></tr>
<tr class="memdesc:ga622145415a86ef826c3e8017fb478db6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe read proto from binary file.  <a href="#ga622145415a86ef826c3e8017fb478db6">More...</a><br/></td></tr>
<tr class="separator:ga622145415a86ef826c3e8017fb478db6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga335d05efc7a9d315db56be13fc0af111"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga335d05efc7a9d315db56be13fc0af111">appCNNInteropCaffeFlipMatrixFloat</a> (float *a, int m, int n)</td></tr>
<tr class="memdesc:ga335d05efc7a9d315db56be13fc0af111"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flip a matrix.  <a href="#ga335d05efc7a9d315db56be13fc0af111">More...</a><br/></td></tr>
<tr class="separator:ga335d05efc7a9d315db56be13fc0af111"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4d2f15bd3e322f77cbc47edf00f9ef36"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga4d2f15bd3e322f77cbc47edf00f9ef36">appCNNInteropCaffeFlipKernelMatrix</a> (float *kernel, int kernelRow, int kernelCol, int inputChannel, int outputChannel)</td></tr>
<tr class="memdesc:ga4d2f15bd3e322f77cbc47edf00f9ef36"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flip the kernels.  <a href="#ga4d2f15bd3e322f77cbc47edf00f9ef36">More...</a><br/></td></tr>
<tr class="separator:ga4d2f15bd3e322f77cbc47edf00f9ef36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga9a4b55d7ec059ee00c3c6b6d5743f9f7">appCNNInteropCaffeFillBlockDiagonalMatrix</a> (float *a, int M, int N, int group, float *b)</td></tr>
<tr class="memdesc:ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fill a block diagonal matrix.  <a href="#ga9a4b55d7ec059ee00c3c6b6d5743f9f7">More...</a><br/></td></tr>
<tr class="separator:ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga630a9d1314c2151e7193de73a714b789"><td class="memItemLeft" align="right" valign="top">timlUtilActivationType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga630a9d1314c2151e7193de73a714b789">appCNNInteropCaffeNonlinearTypeConvert</a> (LayerParameter_LayerType type)</td></tr>
<tr class="memdesc:ga630a9d1314c2151e7193de73a714b789"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe nonlinear layer type conversion.  <a href="#ga630a9d1314c2151e7193de73a714b789">More...</a><br/></td></tr>
<tr class="separator:ga630a9d1314c2151e7193de73a714b789"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3752b452e61029bc03d4f10b95d0a861"><td class="memItemLeft" align="right" valign="top">timlCNNLayerType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga3752b452e61029bc03d4f10b95d0a861">appCNNInteropCaffeLayerTypeConvert</a> (LayerParameter_LayerType type)</td></tr>
<tr class="memdesc:ga3752b452e61029bc03d4f10b95d0a861"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe to TIML CNN layer type conversion.  <a href="#ga3752b452e61029bc03d4f10b95d0a861">More...</a><br/></td></tr>
<tr class="separator:ga3752b452e61029bc03d4f10b95d0a861"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3106ebef164cd39f0bc864c59c2c0a45"><td class="memItemLeft" align="right" valign="top">timlCNNPoolingType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga3106ebef164cd39f0bc864c59c2c0a45">appCNNInteropCaffePoolingTypeConvert</a> (PoolingParameter_PoolMethod method)</td></tr>
<tr class="memdesc:ga3106ebef164cd39f0bc864c59c2c0a45"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe pooling type conversion.  <a href="#ga3106ebef164cd39f0bc864c59c2c0a45">More...</a><br/></td></tr>
<tr class="separator:ga3106ebef164cd39f0bc864c59c2c0a45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2ce06f0ef11d677b3087a59857797335"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga2ce06f0ef11d677b3087a59857797335">appCNNInteropCaffeConvert</a> (const char *netStructurePrototxtFileName, const char *netParamPrototxtFileName)</td></tr>
<tr class="memdesc:ga2ce06f0ef11d677b3087a59857797335"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert Caffe to TIML CNN.  <a href="#ga2ce06f0ef11d677b3087a59857797335">More...</a><br/></td></tr>
<tr class="separator:ga2ce06f0ef11d677b3087a59857797335"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga17ffed596b6ee6d57574915f1eaaaf23"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga17ffed596b6ee6d57574915f1eaaaf23">appCNNInteropCaffeConvLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:ga17ffed596b6ee6d57574915f1eaaaf23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert Caffe conv layer.  <a href="#ga17ffed596b6ee6d57574915f1eaaaf23">More...</a><br/></td></tr>
<tr class="separator:ga17ffed596b6ee6d57574915f1eaaaf23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9dfa0736763aefc3d820ca27e7a19882"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga9dfa0736763aefc3d820ca27e7a19882">appCNNInteropCaffeConvLayerPermuteKernel</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga9dfa0736763aefc3d820ca27e7a19882"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change the kernel from BGR squence to RGB.  <a href="#ga9dfa0736763aefc3d820ca27e7a19882">More...</a><br/></td></tr>
<tr class="separator:ga9dfa0736763aefc3d820ca27e7a19882"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae61e927bb0b0fd6cca3dd1a45f8a1e62"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gae61e927bb0b0fd6cca3dd1a45f8a1e62">appCNNInteropCaffePoolingLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:gae61e927bb0b0fd6cca3dd1a45f8a1e62"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe pooling layer conversion.  <a href="#gae61e927bb0b0fd6cca3dd1a45f8a1e62">More...</a><br/></td></tr>
<tr class="separator:gae61e927bb0b0fd6cca3dd1a45f8a1e62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7ac38ac27f861867ee84e038428d2139"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga7ac38ac27f861867ee84e038428d2139">appCNNInteropCaffeNormLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:ga7ac38ac27f861867ee84e038428d2139"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe norm layer conversion.  <a href="#ga7ac38ac27f861867ee84e038428d2139">More...</a><br/></td></tr>
<tr class="separator:ga7ac38ac27f861867ee84e038428d2139"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga53805074229f6d101a0b3c91dce8216b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga53805074229f6d101a0b3c91dce8216b">appCNNInteropCaffeLinearLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:ga53805074229f6d101a0b3c91dce8216b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe linear layer conversion.  <a href="#ga53805074229f6d101a0b3c91dce8216b">More...</a><br/></td></tr>
<tr class="separator:ga53805074229f6d101a0b3c91dce8216b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab913f62c0b33ce7bc646d2877e9fb748"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gab913f62c0b33ce7bc646d2877e9fb748">appCNNInteropCaffeNonlinearLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:gab913f62c0b33ce7bc646d2877e9fb748"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe nonlinear layer conversion.  <a href="#gab913f62c0b33ce7bc646d2877e9fb748">More...</a><br/></td></tr>
<tr class="separator:gab913f62c0b33ce7bc646d2877e9fb748"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf982a0ff86bbbfffaa342f80b3f46cb5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gaf982a0ff86bbbfffaa342f80b3f46cb5">appCNNInteropCaffeDropoutLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:gaf982a0ff86bbbfffaa342f80b3f46cb5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe dropout layer conversion.  <a href="#gaf982a0ff86bbbfffaa342f80b3f46cb5">More...</a><br/></td></tr>
<tr class="separator:gaf982a0ff86bbbfffaa342f80b3f46cb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab530bd6ef77e6850fb50355ce85f8ff8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gab530bd6ef77e6850fb50355ce85f8ff8">appCNNInteropCaffeReadMean</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, const char *fileName)</td></tr>
<tr class="memdesc:gab530bd6ef77e6850fb50355ce85f8ff8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read Caffe mean binary file.  <a href="#gab530bd6ef77e6850fb50355ce85f8ff8">More...</a><br/></td></tr>
<tr class="separator:gab530bd6ef77e6850fb50355ce85f8ff8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa86fc855715a800c4e27a31159c39207"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gaa86fc855715a800c4e27a31159c39207">appCNNInteropCaffePermuteMean</a> (float *mean, int row, int col, int channel)</td></tr>
<tr class="memdesc:gaa86fc855715a800c4e27a31159c39207"><td class="mdescLeft">&#160;</td><td class="mdescRight">Permute the mean in the input layer from BGR sequence to RGB.  <a href="#gaa86fc855715a800c4e27a31159c39207">More...</a><br/></td></tr>
<tr class="separator:gaa86fc855715a800c4e27a31159c39207"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>CNN Caffe interoperation applications. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga2ce06f0ef11d677b3087a59857797335"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> * appCNNInteropCaffeConvert </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>netStructurePrototxtFileName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>netParamPrototxtFileName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert Caffe to TIML CNN. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">netStructurePrototxtFileName</td><td>Net structure prototxt file name </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">netParamPrototxtFileName</td><td>Net params prototxt file name </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>CNN </dd></dl>

</div>
</div>
<a class="anchor" id="ga17ffed596b6ee6d57574915f1eaaaf23"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeConvLayerConvert </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerStructure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerParam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert Caffe conv layer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerStructure</td><td>Layer structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerParam</td><td>Layer params </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga9dfa0736763aefc3d820ca27e7a19882"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeConvLayerPermuteKernel </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *&#160;</td>
          <td class="paramname"><em>layer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Change the kernel from BGR squence to RGB. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">layer</td><td>Layer ptr </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gaf982a0ff86bbbfffaa342f80b3f46cb5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeDropoutLayerConvert </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerStructure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerParam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe dropout layer conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerStructure</td><td>Layer structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerParam</td><td>Layer params </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga9a4b55d7ec059ee00c3c6b6d5743f9f7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeFillBlockDiagonalMatrix </td>
          <td>(</td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>N</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>group</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>b</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Fill a block diagonal matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">a</td><td>Block diagonal matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">M</td><td>Rows of a </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">N</td><td>Cols of a </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">group</td><td>Number of groups </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">b</td><td>Diagonal blocks </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga4d2f15bd3e322f77cbc47edf00f9ef36"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeFlipKernelMatrix </td>
          <td>(</td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>kernel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>kernelRow</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>kernelCol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inputChannel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>outputChannel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flip the kernels. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">kernel</td><td>Kernel matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">kernelRow</td><td>Kernel rows </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">kernelCol</td><td>Kernel cols </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inputChannel</td><td>Input feature map channels </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">outputChannel</td><td>Output feature map channels </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga335d05efc7a9d315db56be13fc0af111"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeFlipMatrixFloat </td>
          <td>(</td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flip a matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">a</td><td>Matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">m</td><td>Rows </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">n</td><td>Cols </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga3752b452e61029bc03d4f10b95d0a861"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">timlCNNLayerType appCNNInteropCaffeLayerTypeConvert </td>
          <td>(</td>
          <td class="paramtype">LayerParameter_LayerType&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe to TIML CNN layer type conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">type</td><td>Caffe layer type </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TIML CNN layer type </dd></dl>

</div>
</div>
<a class="anchor" id="ga53805074229f6d101a0b3c91dce8216b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeLinearLayerConvert </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerStructure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerParam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe linear layer conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerStructure</td><td>Layer structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerParam</td><td>Layer param </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gab913f62c0b33ce7bc646d2877e9fb748"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeNonlinearLayerConvert </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerStructure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerParam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe nonlinear layer conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerStructure</td><td>Layer structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerParam</td><td>Layer param </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga630a9d1314c2151e7193de73a714b789"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">timlUtilActivationType appCNNInteropCaffeNonlinearTypeConvert </td>
          <td>(</td>
          <td class="paramtype">LayerParameter_LayerType&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe nonlinear layer type conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">type</td><td>Caffe layer type </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TIML CNN nonlinear layer type </dd></dl>

</div>
</div>
<a class="anchor" id="ga7ac38ac27f861867ee84e038428d2139"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeNormLayerConvert </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerStructure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerParam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe norm layer conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerStructure</td><td>Layer structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerParam</td><td>Layer params </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gaa86fc855715a800c4e27a31159c39207"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffePermuteMean </td>
          <td>(</td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>mean</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>channel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Permute the mean in the input layer from BGR sequence to RGB. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">mean</td><td>Mean matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">row</td><td>Rows </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">col</td><td>Cols </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">channel</td><td>Channels </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gae61e927bb0b0fd6cca3dd1a45f8a1e62"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffePoolingLayerConvert </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerStructure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LayerParameter&#160;</td>
          <td class="paramname"><em>layerParam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe pooling layer conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerStructure</td><td>Layer structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">layerParam</td><td>Layer params </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga3106ebef164cd39f0bc864c59c2c0a45"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">timlCNNPoolingType appCNNInteropCaffePoolingTypeConvert </td>
          <td>(</td>
          <td class="paramtype">PoolingParameter_PoolMethod&#160;</td>
          <td class="paramname"><em>method</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe pooling type conversion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">method</td><td>Caffe pooling method </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TIML CNN pooling type </dd></dl>

</div>
</div>
<a class="anchor" id="gab530bd6ef77e6850fb50355ce85f8ff8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNInteropCaffeReadMean </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *&#160;</td>
          <td class="paramname"><em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>fileName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read Caffe mean binary file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">layer</td><td>Input layer ptr </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fileName</td><td>File name </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga622145415a86ef826c3e8017fb478db6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool appCNNInteropCaffeReadProtoFromBinaryFile </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>fileName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Message *&#160;</td>
          <td class="paramname"><em>proto</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe read proto from binary file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">fileName</td><td>File name </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">proto</td><td>Proto </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Status </dd></dl>

</div>
</div>
<a class="anchor" id="ga7052f4eb157d65957ad3fd2332438522"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool appCNNInteropCaffeReadProtoFromTextFile </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>fileName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Message *&#160;</td>
          <td class="paramname"><em>proto</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe read proto from text file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">fileName</td><td>File name </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">proto</td><td>Proto </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Status </dd></dl>

</div>
</div>
<a class="anchor" id="ga0ddf1224851353fc92bfbff6f499fa97"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int main </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>argv</em>[]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Caffe to TIML CNN model converter. </p>
<p>argv[0] = program name argv[1] = saved timl CNN model file name argv[2] = Caffe model text file name argv[3] = Caffe model binary file name argv[4] = Caffe mean binary file name (optional) </p>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
